{+******************************************************************************+
|  TGaugeCAption es un control TGauge con varias propiedades nuevas.            |
|  En primer lugar permite un Caption que aparecer junto al porcentaje.        |
|  Puede ser mostrada a izquierda o derecha. Adems, posee tres modos:          |
| (En la propiedad temperatura):                                                |
|- tNormal: El clsico TGauge.                                                  |
|- tTemperatura: El Gauge toma tres colores (ColdColor para un progreso de 25   |
|  o menos, MedColor para un progreso entre 26 y 75 y HotColor para un progreso |
|  superior a 100);                                                             |
|- tDegradado: El Gauge toma un color degradado entre ColdColor (Progress 0) y  |
| HotColor (Progress 100).                                                      |
|                                                                               |
| Este producto es Freeware y puedes usarlo sin restricciones. Puedes cambiar,  |
| modificar o mejorar el cdigo para que se ajuste a tus gustos y puedes usarlo |
| en                                                                            |
| cualquier aplicacin sin ningn impedimento. Si encuentras algn fallo,       |
| quieres darme tu opinin, quieres comunicarme algn cambio en el cdigo o     |
| para cualquier contacto Tzimisce2003@Iespana.es                               |
|                                                                               |
|[I apologyze for my bad english. I hope you can understand this ;)]            |
|                                                                               |
| TGaugeCaption is a TGauge control with some new properties. It has a Caption  |
| property that is showed besides the porcentage value. This Caption can be at  |
| left or at rigth of the progress value. In addition, the GaugeCaption haave   |
| three modes (find them in temperature property):                              |
|- tNormal: It's the classic Tgauge.                                            |
|- tTemperatura: The Gauge is painted whit a color that depends of the          |
|  progress value. ColdColor is for progress lower than 26, Med Color is for    |
|  Progress between 26 and 75 and HotColor is for Progress bigger than 75.      |
|- tDegradado: The Gauge is painted with a degree color between ColdColor       |
| (Progress 0) and HotColor (Progress 100).                                     |
|                                                                               |
| This Control es freeware. You can use it without restrictions and you can     |
| make any change or improve freely. Also, you can use this in any application  |
| without permission. If you find any bug, want to give me your opinion about   |
| this                                                                          |
| or simply for contact Tzimisce2003@Iespana.es.                                |
|                                                                               |
|Por Dr Juzam 2004                                                              |
+*******************************************************************************+}

unit gaugeCaption;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, StdCtrls, Gauges;

type
  TTemperature= (tNormal, tDegradado, tTemperatura);
  TPosicion= (poIzquierda, poDerecha);
  TGaugeKind = (gkText, gkHorizontalBar, gkVerticalBar, gkPie, gkNeedle);
  tgaugeCaption = class(TGauge)
  private
    FMinValue: Longint;
    FMaxValue: Longint;
    FCurValue: Longint;
    FKind: TGaugeKind;
    FShowText: Boolean;
    FBorderStyle: TBorderStyle;
    FForeColor: TColor;
    FBackColor: TColor;
    FColdColor: TColor;
    FMedColor: TColor;
    FHotColor: TColor;
    FPosicion: TPosicion;
    FCaption: TCaption;
    FTemperature: TTemperature;
    procedure PaintBackground(AnImage: TBitmap);
    procedure PaintAsText(AnImage: TBitmap; PaintRect: TRect);
    procedure PaintAsNothing(AnImage: TBitmap; PaintRect: TRect);
    procedure PaintAsBar(AnImage: TBitmap; PaintRect: TRect);
    procedure PaintAsPie(AnImage: TBitmap; PaintRect: TRect);
    procedure PaintAsNeedle(AnImage: TBitmap; PaintRect: TRect);
    procedure SetGaugeKind(Value: TGaugeKind);
    procedure SetShowText(Value: Boolean);
    procedure SetBorderStyle(Value: TBorderStyle);
    procedure SetForeColor(Value: TColor);
    procedure SetColdColor (Value: TColor); //Avance menor 25%
    procedure SetMedColor (Value: TColor);  //Avance entre 25 y 75%
    procedure SetHotColor (Value: TColor);  //Avance mayor al 75%
    procedure SetTemperature (Value: TTemperature); //Diferentes colores para la barra segn el avance
    procedure SetBackColor(Value: TColor);
    procedure SetCaption(Value: TCaption);
    procedure SetMinValue(Value: Longint);
    procedure SetMaxValue(Value: Longint);
    procedure SetProgress(Value: Longint);
    procedure SetPosicion (Value: TPosicion);  //coloca el Caption a izq o der del Progreso
    function GetPercentDone: Longint;
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure AddProgress(Value: Longint);
    property PercentDone: Longint read GetPercentDone;
  published
    property Align;
    property Anchors;
    property BackColor: TColor read FBackColor write SetBackColor default clWhite;
    property BorderStyle: TBorderStyle read FBorderStyle write SetBorderStyle default bsSingle;
    property Caption: TCaption read FCaption write SetCaption;
    property Color;
    property Constraints;
    property Temperature: TTemperature read FTemperature write SetTemperature default tNormal;
    property Enabled;
    property ForeColor: TColor read FForeColor write SetForeColor default clBlack;
    property ColdColor: TColor read FColdColor write SetColdColor default clNavy;
    property MedColor: TColor read FMedColor write SetMedColor default clLime;
    property HotColor: TColor read FHotColor write SetHotColor default clRed;
    property Font;
    property Kind: TGaugeKind read FKind write SetGaugeKind default gkHorizontalBar;
    property MinValue: Longint read FMinValue write SetMinValue default 0;
    property MaxValue: Longint read FMaxValue write SetMaxValue default 100;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property Posicion: TPosicion read FPosicion write SetPosicion default poIzquierda;
    property Progress: Longint read FCurValue write SetProgress;
    property ShowHint;
    property ShowText: Boolean read FShowText write SetShowText default True;
    property Visible;
  end;

procedure Register;

implementation


uses Consts;

type
  TBltBitmap = class(TBitmap)
    procedure MakeLike(ATemplate: TBitmap);
  end;

{ TBltBitmap }

procedure Register;
begin
  RegisterComponents('Samples', [TGaugeCaption]);
end;

procedure TBltBitmap.MakeLike(ATemplate: TBitmap);
begin
  Width := ATemplate.Width;
  Height := ATemplate.Height;
  Canvas.Brush.Color := clWindowFrame;
  Canvas.Brush.Style := bsSolid;
  Canvas.FillRect(Rect(0, 0, Width, Height));
end;

{ This function solves for x in the equation "x is y% of z". }
function SolveForX(Y, Z: Longint): Longint;
begin
  Result := Longint(Trunc( Z * (Y * 0.01) ));
end;

{ This function solves for y in the equation "x is y% of z". }
function SolveForY(X, Z: Longint): Longint;
begin
  if Z = 0 then Result := 0
  else Result := Longint(Trunc( (X * 100.0) / Z ));
end;

{ TGaugeCaption }

constructor TGaugeCaption.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csFramed, csOpaque];
  { default values }
  FMinValue := 0;
  FMaxValue := 100;
  FCurValue := 0;
  FKind := gkHorizontalBar;
  FShowText := True;
  FBorderStyle := bsSingle;
  FForeColor := clBlack;
  FBackColor := clWhite;
  FColdColor:= clAqua;
  FMedColor:= clBlue;
  FHotColor:= $00BB0000; //Un poco ms oscuro que el clBlue
  FPosicion := poIzquierda;
  FTemperature:= tNormal;
  Width := 100;
  Height := 25;
end;

function TGaugeCaption.GetPercentDone: Longint;
begin
  Result := SolveForY(FCurValue - FMinValue, FMaxValue - FMinValue);
end;

procedure TGaugeCaption.Paint;
var
  TheImage: TBitmap;
  OverlayImage: TBltBitmap;
  PaintRect: TRect;
begin
  with Canvas do
  begin
    TheImage := TBitmap.Create;
    try
      TheImage.Height := Height;
      TheImage.Width := Width;
      PaintBackground(TheImage);
      PaintRect := ClientRect;
      if FBorderStyle = bsSingle then InflateRect(PaintRect, -1, -1);
      OverlayImage := TBltBitmap.Create;
      try
        OverlayImage.MakeLike(TheImage);
        PaintBackground(OverlayImage);
        case FKind of
          gkText: PaintAsNothing(OverlayImage, PaintRect);
          gkHorizontalBar, gkVerticalBar: PaintAsBar(OverlayImage, PaintRect);
          gkPie: PaintAsPie(OverlayImage, PaintRect);
          gkNeedle: PaintAsNeedle(OverlayImage, PaintRect);
        end;
        TheImage.Canvas.CopyMode := cmSrcInvert;
        TheImage.Canvas.Draw(0, 0, OverlayImage);
        TheImage.Canvas.CopyMode := cmSrcCopy;
        if ShowText then PaintAsText(TheImage, PaintRect);
      finally
        OverlayImage.Free;
      end;
      Canvas.CopyMode := cmSrcCopy;
      Canvas.Draw(0, 0, TheImage);
    finally
      TheImage.Destroy;
    end;
  end;
end;

procedure TGaugeCaption.PaintBackground(AnImage: TBitmap);
var
  ARect: TRect;
begin
  with AnImage.Canvas do
  begin
    CopyMode := cmBlackness;
    ARect := Rect(0, 0, Width, Height);
    CopyRect(ARect, Animage.Canvas, ARect);
    CopyMode := cmSrcCopy;
  end;
end;

procedure TGaugeCaption.PaintAsText(AnImage: TBitmap; PaintRect: TRect);
var
  S: string;
  X, Y: Integer;
  OverRect: TBltBitmap;
begin
  OverRect := TBltBitmap.Create;
  try
    OverRect.MakeLike(AnImage);
    PaintBackground(OverRect);
    if (Posicion=poIzquierda) then
     S := FCaption+' '+Format('%d%%', [PercentDone])
    else
     S := Format('%d%%', [PercentDone])+' '+FCaption;
    with OverRect.Canvas do
    begin
      Brush.Style := bsClear;
      Font := Self.Font;
      Font.Color := clWhite;
      with PaintRect do
      begin
        X := (Right - Left + 1 - TextWidth(S)) div 2;
        Y := (Bottom - Top + 1 - TextHeight(S)) div 2;
      end;
      TextRect(PaintRect, X, Y, S);
    end;
    AnImage.Canvas.CopyMode := cmSrcInvert;
    AnImage.Canvas.Draw(0, 0, OverRect);
  finally
    OverRect.Free;
  end;
end;

procedure TGaugeCaption.PaintAsNothing(AnImage: TBitmap; PaintRect: TRect);
begin
  with AnImage do
  begin
    Canvas.Brush.Color := BackColor;
    Canvas.FillRect(PaintRect);
  end;
end;

procedure TGaugeCaption.PaintAsBar(AnImage: TBitmap; PaintRect: TRect);
var
  FillSize: Longint;
  W, H: Integer;
  R, G, B: Byte;   //ColdColor colores RGB
  FR, FG, FB: Byte;  //HotColor colores RGB
  Rojo, Verde, Azul: Byte;  //Color final
begin
  W := PaintRect.Right - PaintRect.Left + 1;
  H := PaintRect.Bottom - PaintRect.Top + 1;
  with AnImage.Canvas do
  begin
    Brush.Color := BackColor;
    FillRect(PaintRect);
    Pen.Color := ForeColor;
    Pen.Width := 1;
    Case Temperature of
    tNormal: Brush.Color := ForeColor;            //Pintamos por temperatura?
    tDegradado: begin
                if MaxValue=0 then MaxValue:=1; //Evita el fallo por Div 0
                R:=GetRValue (ColdColor);     //Separamos los colores
                G:=GetGValue (ColdColor);
                B:=GetBValue (ColdColor);
                FR:=GetRValue (HotColor);
                FG:=GetGValue (HotColor);
                FB:=GetBValue (HotColor);
                Rojo:=Round((R*(MaxValue-Progress)+FR*(Progress))div MaxValue);
                Verde:=Round((G*(MaxValue-Progress)+FG*(Progress))div Maxvalue);
                Azul:=Round((B*(MaxValue-Progress)+FB*(Progress))div MaxValue);
                Brush.Color:=RGB(Rojo, Verde, Azul);
                end;
    tTemperatura: case Progress of
                        1..25:    Brush.Color := ColdColor;
                        26..75:   Brush.Color := MedColor;
                        76..100:  Brush.Color := HotColor;
                        end
     end ;
    case FKind of
      gkHorizontalBar:
        begin
          FillSize := SolveForX(PercentDone, W);
          if FillSize > W then FillSize := W;
          if FillSize > 0 then FillRect(Rect(PaintRect.Left, PaintRect.Top,
            FillSize, H));
        end;
      gkVerticalBar:
        begin
          FillSize := SolveForX(PercentDone, H);
          if FillSize >= H then FillSize := H - 1;
          FillRect(Rect(PaintRect.Left, H - FillSize, W, H));
        end;
    end;
  end;
end;

procedure TGaugeCaption.PaintAsPie(AnImage: TBitmap; PaintRect: TRect);
var
  MiddleX, MiddleY: Integer;
  Angle: Double;
  W, H: Integer;
  R, G, B: Byte;   //ColdColor colores RGB
  FR, FG, FB: Byte;  //HotColor colores RGB
  Rojo, Verde, Azul: Byte;  //Color final
begin
  W := PaintRect.Right - PaintRect.Left;
  H := PaintRect.Bottom - PaintRect.Top;
  if FBorderStyle = bsSingle then
  begin
    Inc(W);
    Inc(H);
  end;
  with AnImage.Canvas do
  begin
    Brush.Color := Color;
    FillRect(PaintRect);
    Brush.Color := BackColor;
    Pen.Color := ForeColor;
    Pen.Width := 1;
    Ellipse(PaintRect.Left, PaintRect.Top, W, H);
    if PercentDone > 0 then
    begin
    Case Temperature of
    tNormal: Brush.Color := ForeColor;            //Pintamos por temperatura?
    tDegradado: begin
                if MaxValue=0 then MaxValue:=1; //Evita el fallo por Div 0
                R:=GetRValue (ColdColor);
                G:=GetGValue (ColdColor);
                B:=GetBValue (ColdColor);
                FR:=GetRValue (HotColor);
                FG:=GetGValue (HotColor);
                FB:=GetBValue (HotColor);
                Rojo:=Round((R*(MaxValue-Progress)+FR*(Progress))div MaxValue);
                Verde:=Round((G*(MaxValue-Progress)+FG*(Progress))div Maxvalue);
                Azul:=Round((B*(MaxValue-Progress)+FB*(Progress))div MaxValue);
                Brush.Color:=RGB(Rojo, Verde, Azul);
                end;
    tTemperatura: case Progress of
                        1..25:    Brush.Color := ColdColor;
                        26..75:   Brush.Color := MedColor;
                        76..100:  Brush.Color := HotColor;
                        end
     end;
      MiddleX := W div 2;
      MiddleY := H div 2;
      Angle := (Pi * ((PercentDone / 50) + 0.5));
      Pie(PaintRect.Left, PaintRect.Top, W, H,
        Integer(Round(MiddleX * (1 - Cos(Angle)))),
        Integer(Round(MiddleY * (1 - Sin(Angle)))), MiddleX, 0);
    end;
  end;
end;

procedure TGaugeCaption.PaintAsNeedle(AnImage: TBitmap; PaintRect: TRect);
var
  MiddleX: Integer;
  Angle: Double;
  X, Y, W, H: Integer;
  R, G, B: Byte;   //ColdColor colores RGB
  FR, FG, FB: Byte;  //HotColor colores RGB
  Rojo, Verde, Azul: Byte;  //Color final
begin
  with PaintRect do
  begin
    X := Left;
    Y := Top;
    W := Right - Left;
    H := Bottom - Top;
    if FBorderStyle = bsSingle then
    begin
      Inc(W);
      Inc(H);
    end;
  end;
  with AnImage.Canvas do
  begin
    Case Temperature of
    tNormal: Brush.Color := ForeColor;            //Pintamos por temperatura?
    tDegradado: begin
                if MaxValue=0 then MaxValue:=1; //Evita el fallo por Div 0
                R:=GetRValue (ColdColor);
                G:=GetGValue (ColdColor);
                B:=GetBValue (ColdColor);
                FR:=GetRValue (HotColor);
                FG:=GetGValue (HotColor);
                FB:=GetBValue (HotColor);
                Rojo:=Round((R*(MaxValue-Progress)+FR*(Progress))div MaxValue);
                Verde:=Round((G*(MaxValue-Progress)+FG*(Progress))div Maxvalue);
                Azul:=Round((B*(MaxValue-Progress)+FB*(Progress))div MaxValue);
                Brush.Color:=RGB(Rojo, Verde, Azul);
                end;
    tTemperatura: case Progress of
                        1..25:    Brush.Color := ColdColor;
                        26..75:   Brush.Color := MedColor;
                        76..100:  Brush.Color := HotColor;
                        end
     end;
    FillRect(PaintRect);
    Brush.Color := BackColor;
    Pen.Color := ForeColor;
    Pen.Width := 1;
    Pie(X, Y, W, H * 2 - 1, X + W, PaintRect.Bottom - 1, X, PaintRect.Bottom - 1);
    MoveTo(X, PaintRect.Bottom);
    LineTo(X + W, PaintRect.Bottom);
    if PercentDone > 0 then
    begin
      Pen.Color := ForeColor;
      MiddleX := Width div 2;
      MoveTo(MiddleX, PaintRect.Bottom - 1);
      Angle := (Pi * ((PercentDone / 100)));
      LineTo(Integer(Round(MiddleX * (1 - Cos(Angle)))),
        Integer(Round((PaintRect.Bottom - 1) * (1 - Sin(Angle)))));
    end;
  end;
end;

procedure TGaugeCaption.SetGaugeKind(Value: TGaugeKind);
begin
  if Value <> FKind then
  begin
    FKind := Value;
    Refresh;
  end;
end;

procedure TGaugeCaption.SetShowText(Value: Boolean);
begin
  if Value <> FShowText then
  begin
    FShowText := Value;
    Refresh;
  end;
end;

procedure TGaugeCaption.SetBorderStyle(Value: TBorderStyle);
begin
  if Value <> FBorderStyle then
  begin
    FBorderStyle := Value;
    Refresh;
  end;
end;

procedure TGaugeCaption.SetForeColor(Value: TColor);
begin
  if Value <> FForeColor then
  begin
    FForeColor := Value;
    Refresh;
  end;
end;

procedure TGaugeCaption.SetPosicion (value: TPosicion);
begin
  if Value <> FPosicion then
  begin
    FPosicion := Value;
    Refresh;
  end;
end;

procedure TGaugeCaption.SetBackColor(Value: TColor);
begin
  if Value <> FBackColor then
  begin
    FBackColor := Value;
    Refresh;
  end;
end;

procedure TGaugeCaption.SetMinValue(Value: Longint);
begin
  if Value <> FMinValue then
  begin
    if Value > FMaxValue then
      if not (csLoading in ComponentState) then
        raise EInvalidOperation.CreateFmt(SOutOfRange, [-MaxInt, FMaxValue - 1]);
    FMinValue := Value;
    if FCurValue < Value then FCurValue := Value;
    Refresh;
  end;
end;

procedure TGaugeCaption.SetMaxValue(Value: Longint);
begin
  if Value <> FMaxValue then
  begin
    if Value < FMinValue then
      if not (csLoading in ComponentState) then
        raise EInvalidOperation.CreateFmt(SOutOfRange, [FMinValue + 1, MaxInt]);
    FMaxValue := Value;
    if FCurValue > Value then FCurValue := Value;
    Refresh;
  end;
end;

procedure TGaugeCaption.SetCaption(Value: TCaption);
begin
  if Value <> FCaption then
  begin
    FCaption := Value;
    Refresh;
  end;
end;

procedure TGaugeCaption.SetProgress(Value: Longint);
var
  TempPercent: Longint;
begin
  TempPercent := GetPercentDone;  { remember where we were }
  if Value < FMinValue then
    Value := FMinValue
  else if Value > FMaxValue then
    Value := FMaxValue;
  if FCurValue <> Value then
  begin
    FCurValue := Value;
    if TempPercent <> GetPercentDone then { only refresh if percentage changed }
      Refresh;
  end;
end;

procedure TGaugeCaption.SetColdColor(Value: TColor);
begin
 if Value<>FColdColor then begin
  FColdColor:=Value;
  Refresh;
 end;
end;

procedure TGaugeCaption.SetMedColor(Value: TColor);
begin
 if Value<>FMedColor then begin
  FMedColor:=Value;
  Refresh;
 end;
end;

procedure TGaugeCaption.SetHotColor(Value: TColor);
begin
 if Value<>FHotColor then begin
  FHotColor:=Value;
  Refresh;
 end;
end;

procedure TGaugeCaption.SetTemperature(Value: TTemperature);
begin
  if Value<>FTemperature then begin
   FTemperature:=Value;
   Refresh;
 end;
end;

procedure TGaugeCaption.AddProgress(Value: Longint);
begin
  Progress := FCurValue + Value;
  Refresh;
end;

end.
