{+-----------------------------------------------------------------------------+
 | El NumEdit es un control que desciende del TEdit y que acepta nicamente    |
 | numricos. Posee dos propiedades booleanas PermitirDec y PermitirNeg que    |
 | si se pueden introducir valores decimales y negativos, respectivamente. Dado|
 | que el Edit sigue trabajando con el valor como Texto, he incluido una       |
 | funcin DarValor que devuelve el contenido del NumEdit en una variable      |
 | variant, para que no tengas que andar con conversiones.                     |
 | Este producto es Freeware y puedes usarlo sin restricciones. Puedes cambiar,|
 | modificar o mejorar el cdigo para que se ajuste a tus gustos y puedes      |
 | usarlo en                                                                   |
 | cualquier aplicacin sin ningn impedimento. Si encuentras algn fallo,     |
 | quieres darme tu opinin, quieres comunicarme algn cambio en el cdigo o   |
 | para cualquier contacto Tzimisce2003@Iespana.es                             |
 | [I'm try to explain it in English. ;)]                                      |
 | NumEdit is a descendant of Tedit with only accepts numeric values. It has   |
 | two bool properties: PermitirDec and PermitirNeg. The first one allows the  |
 | decimal values. The second allows negative values. The NumEdit value is     |
 | still a text value. For this I've include a function DarValor who returns   |
 | the Text in a Variant type. Thus, you must not work with conversion.        |
 | This Control es freeware. You can use it without restrictions and you can   |
 | make any change or improve freely. Also, you can use this in any application|
 | without permission. If you find any bug, want to give me your opinion about |
 |this or simply for contact Tzimisce2003@Iespana.es.                          |
 |                                                                             |
 | Por Dr Juzam 2004                                                           |
 +-----------------------------------------------------------------------------+}
unit NumEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls, Variants;

type
  TNumEdit = class(TEdit)
  private
   FPermitirNeg: Bool;
   FPermitirDec: Bool;
    { Private declarations }
  protected
   procedure KeyPress(var Key: Char); override;
   procedure SetPermitirNeg (value: Bool);
   procedure SetPermitirDec (value: Bool);
    { Protected declarations }
  public
   Constructor Create (AOwner: TComponent); Override;
   function DarValor: Variant;
    { Public declarations }
  published
   property PermitirNeg: Bool read FPermitirNeg write SetPermitirNeg;
   property PermitirDec: Bool read FPermitirDec write SetPermitirDec;
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('NuevaPaleta', [TNumEdit]);
end;

constructor TNumEdit.Create (AOwner: TComponent);
begin
 inherited Create (AOwner);
 Text:='0'; //Es necesario para que no ponga el nombre del Objeto
end;

procedure TNumEdit.KeyPress(var Key:Char);
var
 PreKey: Char;
 Num: ShortInt;
 Decimal: Bool;
begin
 if Key='.' then Key:=DecimalSeparator;
 PreKey:= Key;
 if Key<> #8 then
  if (Key<#48) or (Key>#57) then
   Key:=#0;
 //Si es signo negativo (-)
 if (FPermitirNeg=true) and (PreKey='-') and (Length(Text)=0)  then
  Key:=PreKey;
 //Si es un decimal
 if (PreKey=DecimalSeparator) and (FPermitirDec=true) then begin
  decimal:=true;
  for Num:=0 to Length(Text) do
   if Text[num]=DecimalSeparator then begin
     Decimal:=false;
     break;
   end;
  if Decimal=true then Key:=PreKey;
 end;
 inherited KeyPress(Key);
 if (Key = Char(VK_RETURN)) then Key := #0;
end;

procedure TNumEdit.SetPermitirNeg(Value: Bool);
var
 Num: Extended;
begin
 if Value<>FPermitirNeg then
  FPermitirNeg:=Value;
 //Comprobacin de integridad
 if (Text<>'') and (Text<>'-') then begin
  Num:=StrToFloat(Text);
  if (Num<0) and (FPermitirNeg=false) then begin
   Num:=(-1)*Num;    //Convierte el numero negativo en positivo
   Text:=FloatToStr(Num);
  end;
 end
 else Clear();
end;

procedure TNumEdit.SetPermitirDec(Value: Bool);
var
 Num: Extended;
begin
 if Value<>FPermitirDec then
  FPermitirDec:=Value;
 //Comprobacin de integridad
 if (Text<>'') and (Text<>'-') then begin
  Num:=StrToFloat(Text);
  Text:=IntToStr(Round(Num));
 end
 else Clear();
end;

function TNumEdit.DarValor: Variant;
begin
 Result:=StrToFloat(Text);
end;

end.
